<!-- todos

RepIss.js: split, reuse

Projects: manage in DB
-->
<!-- QANav Report Tracker Copyright 2004 - 2008 Ronald D. Grindle -->
<%@ page language="java" pageEncoding="utf-8" contentType="text/html;charset=utf-8" %>

<%@ page errorPage="/ErrPage.jsp" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt" %>

<%@ page import="java.util.*" %>

<%@ page import="java.util.ArrayList" %>

<%@ page import="com.qanavigation.Basics.*" %>
<%@ page import="com.qanavigation.QNservices.*" %>

<%@ page import="RTtools.UserMailTool" %>

<fmt:setBundle basename="QNLabels"/>

<% 
	//ResourceBundle resBndl = ResourceBundle.getBundle("QNLabels", request.getLocale() );
	QNRscBundle resBndl = new QNRscBundle( "QNLabels", request.getLocale() );

	boolean isDel;
	boolean isEdit;
	boolean isHandled;
	boolean isUpl;

	int i, x;

	IssRepBld irb;

	String sVal;
	String oStr;

	String author;
	String user;
	String msg;

	String[] row;

	Rslt res = new Rslt( true );
	Rslt aRes = new Rslt( true );
	RsltString fileUID;
	RsltString fileName;
	RsltString UID = new RsltString();
	RsltString rVal = new RsltString();

	RsltTable fileTbl;

	isUpl = false;
	isDel = false;
	isEdit = false;
	isHandled = false;

	fileTbl = new RsltTable();

	SrvltReqTools sTools = new SrvltReqTools( this, request );

	QNDBacc2 dBAcc = new QNDBacc2();

	res.checkRslt( dBAcc );

	user = request.getRemoteUser();
	
	irb = new IssRepBld( dBAcc.m_DB, sTools, QNDefs.c_RMFilePath );

	if( res.checkRslt( irb ) ) {

		// Checking the request
		rVal = sTools.getVal( "QNA" );

		if( 0 == rVal.getString().compareTo( "RepIss" ) ) {

			isHandled = true;
		}
		else {

			if( 0 == rVal.getString().compareTo( "UplIss" ) ) {

				isHandled = true;
				isUpl = true;
			}
			else {
		
				if( 0 == rVal.getString().compareTo( "DelFile" ) ) {

					isHandled = true;
					isDel = true;
				}
				else {
			
					if( 0 == rVal.getString().compareTo( "EditIss" ) ) {

						isHandled = true;
						isEdit = true;
					}
				}
			}
		}

		if( res.isOK() ) {
	
			// Deleting a file ------
			if( isDel ) {

				fileName = sTools.getVal( "DelName" );
				fileUID = sTools.getVal( "DelUID" );

				aRes = irb.deleteFile( fileUID.getString() );

				if( aRes.isOK() ) {

					out.println( "<script type=\"text/javascript\">alert(\" File '" + fileName.getString() + "' was removed.\");</script>" );
				}
				else {

					res.setInError( "Failed to remove file '" + fileName.getString() + "' (" + fileUID.getString() + ")." );
				}
			}

			if( isUpl || isDel ) {

				irb.bldIssRep( true );

				if( res.checkRslt( irb ) ) {
				
					UID = irb.save2DB( user, true );

					res.checkRslt( UID );
				}
			}

			if( isEdit ) {

				UID = sTools.getVal( "UID" );

				if( res.checkRslt( UID ) ) {

					irb.loadIssData( UID.getString() ); 

					res.checkRslt( irb );

					rVal = sTools.getVal( "Author" );

					author = rVal.getString();

					if( user.compareTo( author ) != 0 ) {

						msg = SFormatter.format( resBndl.getString( "msgLastAuthorWas" ), author );  

						irb.appProcLogX( UID.getString(), msg );
					}
				}
			}

			if( res.isOK() && (isUpl || isDel || isEdit ) ) {

				fileTbl = irb.getAppFileData();

				res.checkRslt( fileTbl, true );
			}
		}
	}

%>

<!DOCTYPE html PUBLIC "-//W3C//DTD html 4.0 Transitional//EN">
<html>
	<head>

		<meta name="DC.Title" content="Issue Report Edit">
		<meta name="DC.Creator" content="Ronald D. Grindle">
		<meta name="DC.Publisher" content="QA Navigation">
		<meta name="DC.Date" content="2004-06-12">
		<meta name="DC.Identifier" content="http://www.qa-navigation.com/">
		<meta name="DC.Rights" content="Alle Rechte liegen beim Autor">
		
		<link rel=stylesheet type="text/css" href="QNStyle.css">

		<title>Issue Report Editor</title>

<script type="text/javascript" src="incl/dhtml.js"></script>
<script type="text/javascript" src="incl/PnlTools.js"></script>

<script type="text/javascript">
<!--

<%@ include file="jspf/PnlToolsLbls.jspf" %>

var lblAddDataEtc = <% out.print( "\"" + resBndl.getString( "lblAddDataEtc" ) + "\"" ); %>;
var lblAppl = <% out.print( "\"" + resBndl.getString( "lblAppl" ) + "\"" ); %>;
var lblDate = <% out.print( "\"" + resBndl.getString( "lblDate" ) + "\"" ); %>;
var lblIssType = <% out.print( "\"" + resBndl.getString( "lblIssType" ) + "\"" ); %>;
var lblFctn = <% out.print( "\"" + resBndl.getString( "lblFctn" ) + "\"" ); %>;
var lblTime = <% out.print( "\"" + resBndl.getString( "lblTime" ) + "\"" ); %>;
var lblTitle = <% out.print( "\"" + resBndl.getString( "lblTitle" ) + "\"" ); %>;
var lblUser = <% out.print( "\"" + resBndl.getString( "lblUser" ) + "\"" ); %>;
var lblVer = <% out.print( "\"" + resBndl.getString( "lblVer" ) + "\"" ); %>;


// ------------------------------------------
function presetFromReq() {

<%

	oStr = "preselSelByVal( \"IssType\", \"" + irb.getVal( "IssType" ) + "\" );";
	out.println( oStr );

%>
}

// ------------------------------------------
function doLoadUp() {

	p_FieldName = <% out.print( "\"" + resBndl.getString( "lblAddData" ) + "\"" ); %>;

	theIn = document.getElementsByName( "AppFile" )[0];
	val = theIn.value;

	if( val.length < 1 ) {

		msg = sFormatDec( errFldNotFill, p_FieldName );

		alert( msg );

		theIn.focus();
	}
	else {

		theIn = document.getElementsByName( "QNA" )[0];
		theIn.value = "UplIss";

		document.forms[0].action="RepIss.jsp"
//document.forms[0].action="FileUpload.jsp"

		document.forms[0].submit();
	}	
}

// ------------------------------------------
function Startup() {

//setForTest();
	
	presetFromReq();
}

// -->
</script>

<script type="text/javascript" src="incl/RepIss.js"></script>

</head>

<!-- ------------------------------------------------------------------------ -->
<body bgcolor="#DDCCEE" class="work" onLoad="Startup()">

<%
	if( !isHandled ) {

		res.setInError( "Wrong Application" );
		out.println( "<p>" + resBndl.getString( "errWrongQNAppl" ) + "</p>" );
		out.println( "<script type=\"text/javascript\">notifyErr( \"\" );</script>" );
		
		SrvltReqTools.logErr( this, request, sTools );

		// mild error handling
		res.setOK();
	}
/*
out.println( "<p>Status res: " + RsltStatVal.label[ res.getRsltStatVal() ] + "</p>" );
ArrayList addInfo;
addInfo = res.getRsltAddInfo();
x = addInfo.size();

for( i = 0; i < x; ++i ) {

	out.println( "<br>" + (String)addInfo.get( i ) );
}

if( res.notOK() ) {
out.println( "<script type=\"text/javascript\">notify( \"ProbRepOK\" );</script>" );
res.setOK();
}
*/
	if( res.isOK() ) {

		out.println( "<script type=\"text/javascript\">notify( \"IssRepOK\" );</script>" );
%>
	<form id="MainForm" action="" method="post" onSubmit="return doSubmit();" enctype="multipart/form-data">

	<input name="QNA" type="hidden" value="IssIss"/>
					
	<input name="IssStat" type="hidden" value="dr"/>	

	<input name="DelUID" type="hidden" value=""/>	
	<input name="DelName" type="hidden" value=""/>	

	<table border="1" cellspacing="0" cellpadding="4">

		<tr>
			<td valign="middle" align="center">
				<b><fmt:message key="lblIssue"/></b>
<% 
		oStr = "<input name=\"UID\" type=\"hidden\" value=\"";

		oStr += UID.getString();

		out.println( oStr + "\">" );
%>
			</td>
		</tr>

<!-- Title --------------------- -->

		<tr><td>

			<table border="0" cellspacing="0" cellpadding="4" >

				<tr>
					<td valign="middle" align="left" width="80px">
						<p><fmt:message key="lblTitle"/></p>
					</td>
					<td valign="middle" align="left">
<%
		oStr = "<input name=\"Title\" type=\"text\" size=\"90\" maxlength=\"240\" value=\"";

		oStr += irb.getVal( "Title" );

		out.println( oStr + "\"/>" );
%>
					</td>
				</tr>
			</table>

		</td></tr>
		<tr><td>

			<table border="0" cellspacing="0" cellpadding="4" >

				<tr>
					<td valign="middle" align="left" width="80px">
						<p><fmt:message key="lblIssNr"/></p>
					</td>
					<td valign="middle" align="left">
<%
		oStr = "<input class=\"ro\" name=\"IssNum\" type=\"text\" size=\"6\" maxlength=\"8\" value=\"";

		sVal = irb.getVal( "IssNum" );
		
		if( sVal.length() < 1 ) {

			rVal = dBAcc.m_DB.getIncrCounter( "Counters", "PRCount" );

			if( res.checkRslt( rVal ) ) {

				sVal = rVal.getString();
			}
		}		

		oStr += sVal;

		out.println( oStr + "\" readonly />" );
%>
					</td>
					<td valign="middle" align="left">
						<input name="Prio" type="hidden" value=""/>
					</td>
				</tr>
			</table>

		</td></tr>
		<tr><td>

			<table border="0" cellspacing="0" cellpadding="4">

<!-- Author --------------------- -->

				<tr>
					<td valign="middle" align="left" width="80px">
						<p><fmt:message key="lblAuthor"/></p>
					</td>

					<td valign="middle" align="left">
<%
		oStr = "<input class=\"ro\" name=\"Author\" type=\"text\" size=\"20\" maxlength=\"20\" value=\"";

		oStr += user;

		out.println( oStr + "\" readonly />" );
%>
					</td>

<!-- Date --------------------- -->
					<td valign="middle" align="left">
						<p><fmt:message key="lblDate"/></p>
					</td>

					<td valign="middle" align="left">
<%
		oStr = "<input class=\"ro\" name=\"Date\" type=\"text\" size=\"10\" maxlength=\"14\" value=\"";

		if( !(isUpl || isDel) ) {

			oStr += BTools.getNowISODate();
		}
		else {

			oStr += irb.getVal( "Date" );
		}
		
		out.println( oStr + "\" readonly />" );
%>
					</td>

<!-- Time --------------------- -->
					<td valign="middle" align="left">
						<p><fmt:message key="lblTime"/></p>
					</td>

					<td valign="middle" align="left">
<%

		oStr = "<input class=\"ro\" name=\"Time\" type=\"text\" size=\"6\" maxlength=\"8\" value=\"";

		if( !(isUpl || isDel) ) {

			oStr += BTools.getNowISOTime();
		}
		else {

			oStr += irb.getVal( "Time" );
		}

		out.println( oStr + "\" readonly />" );	
%>
					</td>
				</tr>
			</table>
		</td></tr>
		<tr><td>

			<table border="0" cellspacing="0" cellpadding="4">
				<tr>

<!-- Proj --------------------- -->
					<td valign="middle" align="left">
						<p><fmt:message key="lblProj"/></p>
					</td>
					<td>
						<select name="Proj" size="1">
<%
		/*tableName = "ProdRels";
		appx = " WHERE Prod = '" + appl + "' ORDER BY BINARY Rel DESC";
		colNames = new String[1];
		colNames[0] = "Rel";

		rTbl = dBAcc.m_DB.select( tableName, colNames, appx );

		if( rTbl.isOK() ) {
		
			x = rTbl.size();

			for( i = 0; i < x; ++i ) {
				
				val = rTbl.getCell( 0, i );

				out.println( "<option value=\"" + val + "\">" + val + "</option>" );
			}
		} */
%>
							<option value="WITA 1.100">WITA 1.100</option>
							<option value="WITA 1.200">WITA 1.200</option>
						</select>
					</td>

<!-- Issue Type --------------------- -->
					<td valign="middle" align="left">
						<p><fmt:message key="lblIssType"/></p>
					</td>
					<td>
						<select name="IssType" size="1">

							<option value="er"><fmt:message key="valIssType_er"/></option>
							<option value="rq"><fmt:message key="valIssType_rc"/></option>
						</select>
					</td>
				</tr>
			</table>
		</td></tr>
		<tr><td>

<!-- Text --------------------- -->
			<table border="0" cellspacing="0" cellpadding="4">
				<tr>
					<td valign="middle" align="left">
						<p><fmt:message key="lblIssText"/></p>
					</td>
				</tr>
				<tr>
					<td valign="middle" align="center">
						<textarea name="Text" cols="104" rows="10"><% out.println( irb.getVal( "Text" ) ); %></textarea>
					</td>
				</tr>
			</table>
		
		</td></tr>
		<tr><td>

<!-- Addional Files --------------------- -->
			<table border="2" cellspacing="0" cellpadding="4" width="98%">
				<tr>
					<td valign="middle" align="left">

						<p><fmt:message key="lblAddData"/></p>
					</td>
				</tr>
				<tr><td>
					<table border="0" cellspacing="0" cellpadding="4" width="98%">
						<tr>
							<td valign="middle" align="left" colspan="2">
								<p><fmt:message key="lblSelFilePC"/></p>
							</td>
						</tr>
						<tr>
							<td valign="middle" align="left">
								<input class="ro" id="AppFile" name="AppFile" type="file" size="60"/>
							</td>
							<td valign="middle" align="left">
								<input type="button" style="width:90pt" onclick="rset('AppFile');" value="<fmt:message key="lblReset"/>"/>
							</td>
						</tr>
						<tr>
							<td valign="middle" align="left">
								<p><fmt:message key="lblDesc"/><br>
								<input name="FileDesc" type="text" size="82" maxlength="512" value=""/></p>
							</td>
							<td valign=bottom align="left">				
								<input type="button" style="width:90pt" onclick="doLoadUp();" value="<fmt:message key="lblLoadUp"/>"/>
							</td>
						</tr>
					</table>
				</td></tr>
				<tr><td>
					<table border="1" cellspacing="0" cellpadding="4" width="98%">


<%
		x = fileTbl.getRowNum();

		String p1 = "<tr><td valign=\"center\" align=\"left\" width=\"550pt\"><p><a href=\"Upload/";
		// uid
		//String p2 = "\" type=\"application/octet-stream\">";
		String p2 = "\" type=\"";
		// file type
		String p3 = "\" target=\"_blank\">";
		//String p3 = "\" >";
		// file name
		String p4 = "</a></p><p>" + resBndl.getString( "lblDesc" ) + ":</p><input class=\"ro\" type=\"text\" size=\"82\" value=\"";
		// desc
		String p5 = "\" readonly/></td><td valign=\"center\" align=\"middle\"><input type=\"button\" style=\"width:120px\" onclick=\"doDelete('";
		// uid
		String p6 = "', '";
		// file name
		String p7 = "');\" value=\"" + resBndl.getString( "blblDel" ) + "\"/></td></tr>";

		for( i = 0; i < x; ++i ) {

			row = fileTbl.getRow( i );

			oStr = p1 + row[0] + "/" + row[5] + p2 + row[1] + p3 + row[3] + p4 + row[5] + p5 + row[0] + p6 + row[3] + p7;

			out.println( oStr );
		}
%>
					</table>
				</td></tr>
			</table>
		</td></tr>
	</table>
	</form>
<%
	} 
%>

	<iframe id="selHider" src="javascript:'&lt;html&gt;&lt;/html&gt;';" scrolling="no" frameborder="0" style="position:absolute;width:10;height:10;top:-500;left:50;border:none;display:block;z-index:0;filter:Alpha(opacity=0);"></iframe>

<%@ include file="jspf/ErrHndl.jspf" %>

<%
	dBAcc.close();
%>

</body>
</html>

