<!-- QANav Report Tracker Copyright 2004 - 2008 Ronald D. Grindle -->
<%@ page language="java" pageEncoding="utf-8" contentType="text/html;charset=utf-8" %>
<%@ page isThreadSafe="false" %>
<%@ page errorPage="/ErrPage.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="java.util.ArrayList" %>

<%@ page import="com.qanavigation.Basics.*" %>
<%@ page import="com.qanavigation.QNservices.*" %>

<%@ page import="RTObj.ShpLstObj" %>
<%@ page import="RTObj.RTtoolsObj" %>

<%@ page import="RTtools.UserMailTool" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt" %>
<fmt:setBundle basename="QNLabels"/>

<% 
	ArrayList<String> outLst;

	int i, x;
	int cols = 0;

	Rslt res = new Rslt();
	
	Rslt2DArray woStatLst = new Rslt2DArray( 2 );

	String[] data;
	String oStr;

	String appl = "";
	String assignd = "";
	String author = "";
	String aVal = "";
	String dateTime = "";
	String line = "";
	String ntfyMsg = "";
	String shpDate = "";
	String shpStat = "";
	String user = "";

	String part1, part2, part3;

	res.setOK();

	//ResourceBundle resBndl = ResourceBundle.getBundle("QNLabels", request.getLocale() );
	QNRscBundle resBndl = new QNRscBundle( "QNLabels", request.getLocale() );
	RsltTable rTbl;

	SrvltReqTools sTools = new SrvltReqTools( this, request );

	QNDBacc2 dBAcc = new QNDBacc2();

	UserTool uTool = new UserTool( dBAcc.m_DB );

	ShpLstObj rlo = new ShpLstObj( this, request, dBAcc );
	RTtoolsObj rto = rlo;
	//RTtoolsObj rto = new RTtoolsObj( this, request, dBAcc );
	
	if( res.checkRslt( rlo ) ) {
		
		rlo.prepare();
	}

	user = request.getRemoteUser();
	appl = sTools.getStrVal( QNDefs.c_AttrAppl );
	shpStat = sTools.getStrVal( QNDefs.c_AttrShpStat );
	assignd = sTools.getStrVal( QNDefs.c_AttrAssignd );
	author = sTools.getStrVal( QNDefs.c_AttrAuthor );
	dateTime = sTools.getStrVal( QNDefs.c_AttrDateTime );
	appl = sTools.getStrVal( QNDefs.c_AttrAppl );
	shpDate = sTools.getStrVal( QNDefs.c_AttrDateTimeShip );
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
	<head>

		<TITLE>Shipment Documents List</TITLE>

		<meta name="DC.Title" content="Shipment Documents List"/>
		<meta name="DC.Creator" content="Ronald D. Grindle"/>
		<meta name="DC.Publisher" content="QA Navigation"/>
		<meta name="DC.Date" content="2004-06-12"/>
		<meta name="DC.Identifier" content="http://www.qa-navigation.com/"/>
		<meta name="DC.Rights" content="Alle Rechte liegen beim Autor"/>
		
		<link rel="stylesheet" type="text/css" href="QNStyle.css" />

<script type="text/javascript" src="incl/dhtml.js"></script>
<script type="text/javascript" src="incl/PnlTools.js"></script>
<script type="text/javascript" src="incl/DialTools.js"></script>
<script type="text/javascript" src="incl/TblSort.js"></script>
<script type="text/javascript" src="incl/LstTools.js"></script>
<script type="text/javascript" src="incl/datetimepicker.js"></script>

<script type="text/javascript">
<!--

<%@ include file="jspf/UserRolesScr2.jspf" %>

<%@ include file="jspf/PnlToolsLbls.jspf" %>

var m_UID = "";
var m_User;
var m_noMenue;
var m_Reload;
var m_ImHere;

var m_href = self.location.href;

//var viewAppl = "VQANavDoc";
var viewAppl = "VShpDocFr.jsp";
var viewQNA = <% out.print( "\"" + QNDefs.c_QNAViewShp + "\"" ); %>;

var m_User = <% out.print( "\"" + user + "\"" ); %>;

var blblCancel = <% out.print( "\"" + resBndl.getString( "blblCancel" ) + "\"" ); %>;
var blblDel = <% out.print( "\"" + resBndl.getString( "blblDel" ) + "\"" ); %>;
var blblView = <% out.print( "\"" + resBndl.getString( "blblView" ) + "\"" ); %>;
var blblInNW = <% out.print( "\"" + resBndl.getString( "blblInNW" ) + "\"" ); %>;

var msgDelBrkLnk = <% out.print( "\"" + resBndl.getString( "msgDelBrkLnk" ) + "\"" ); %>;
var msgConfrmDel = <% out.print( "\"" + resBndl.getString( "msgConfrmDel" ) + "\"" ); %>;

// ##########################################
function presetSels() {

<%
	oStr = "preselSelByVal( \"ShipStat\", \"" + shpStat + "\" );";	
	out.println( oStr );
	oStr = "preselSelByVal( \"Assignd\", \"" + assignd + "\" );";
	out.println( oStr );
	oStr = "preselSelByVal( \"Author\", \"" + author + "\" );";
	out.println( oStr );
	oStr = "preselSelByVal( \"Appl\", \"" + appl + "\" );";
	out.println( oStr );
%>
}

// ##########################################
function reLoadLst() {

	frm = document.getElementsByName( "FilterForm" )[0];

	if( frm != null ) {

		if( parent !== undefined ) {

			parent.notifyEvent( "Proc", "" );
		}
		frm.submit();
	}
}

// ##############################################
function Startup() {


	m_noMenue = true;
	m_Reload = false;

	if( MS )  {

		document.body.onclick=MSaClickWin;
	}
	else {

		document.body.addEventListener( "click", aClickWin, true );
	}

	m_ImHere = true;

	presetSels();
	
	assgnOnKeyUp( "fltShpStat", lnchOnReturn );
	assgnOnKeyUp( "fltAssignd", lnchOnReturn );
	assgnOnKeyUp( "fltAuthor", lnchOnReturn );
	assgnOnKeyUp( "fltDateTime", lnchOnReturn );
	assgnOnKeyUp( "fltAppl", lnchOnReturn );
	assgnOnKeyUp( "fltDateTimeShip", lnchOnReturn );
	assgnOnKeyUp( "fltShipRel", lnchOnReturn );

	//sortTbl( "DocLst", "aUp", 3, 3, 0);

}
// -->
</script>
</head>

<body bgcolor="#BBBBDD" class="work" onLoad="Startup()">

<%-- p id="tst1">...</p>
<p id="tst2">...</p>
<p id="tst3">...</p>
<p id="tst4">...</p --%>

<%
	QNDocLstr docLstr = new QNDocLstr( dBAcc.m_DB );

	Rslt2DArray docLst = new Rslt2DArray( true );

	if( docLst.checkRslt( docLstr ) ) {
		
		//docLst = docLstr.getShpDocLst( appl, assignd, author, dateTime, shpDate, shpStat );
		docLst = rlo.m_docLstr.getShpData( rlo.m_paramLst, woStatLst, rlo.m_uGroup, rlo.m_srchTxt, false );
	}
	
	if( docLst.isOK( true ) ) {			

		docLst.sort( 3, false, false );
		ntfyMsg = "ShpDocLstOK";
	}

	if( res.checkRslt( docLst, true ) ) {
		//out.println( "<p style=\"font-size:80%\">" + SFormatter.format( resBndl.getString( "lblNoRec" ), String.valueOf( docLst.size() ) ) + "</p>" );		
%>

		<table class="work" id="DocLst">
		  	<form name="FilterForm" action="ShpDocLst.jsp" method="post">
				<tr>
<%
		cols = 8;
%>
					<td class="work"><b><fmt:message key="lblStatus"/></b></td>
					<td class="work"><b><fmt:message key="lblAssgnd"/></b></td>					
					<td class="work"><b><fmt:message key="lblAuthor"/></b></td>
					<td class="work"><b><fmt:message key="lblDate"/></b></td>
					<td class="work"><b><fmt:message key="lblAppl"/></b></td>
					<td class="work"><b><fmt:message key="lblRel"/></b></td>
					<td class="work"><b><fmt:message key="lblShipDate"/></b></td>
					<td class="work" width="380pt"><b><fmt:message key="lblText"/></b></td>
				</tr>

				<tr>
					<td class="work">
						<select id="fltShpStat" name="ShipStat" size="1">
							<option value=""></option>
<%
out.println( "<option value=\"beta\">" + rto.m_resBndl.getString( "valStat_beta" ) + "</option>");
out.println( "<option value=\"new\">" + rto.m_resBndl.getString( "valStat_new" ) + "</option>");
out.println( "<option value=\"prod\">" + rto.m_resBndl.getString( "valStat_prod" ) + "</option>");
out.println( "<option value=\"rDpl\">" + rto.m_resBndl.getString( "valStat_rDpl" ) + "</option>");
out.println( "<option value=\"rj\">" + rto.m_resBndl.getString( "valStat_rj" ) + "</option>");
out.println( "<option value=\"rProd\">" + rto.m_resBndl.getString( "valStat_rProd" ) + "</option>");
out.println( "<option value=\"rSysTst\">" + rto.m_resBndl.getString( "valStat_rSysTst" ) + "</option>");
out.println( "<option value=\"sysTst\">" + rto.m_resBndl.getString( "valStat_sysTst" ) + "</option>");
%>
						</select>
					</td>
						
					<td class="work">		
						<select id="fltAssignd" name="Assignd" size="1">
							<option value=""></option>
<%
			outLst = rlo.getSrvcLstOpts( rlo.m_assGroup );
	
			x = outLst.size();
			
			for( i = 0; i < x; ++i ) {
				
				out.println( outLst.get( i ) );
			}	
%>
						</select>
					</td>					

					<td class="work">					
						<select id="fltAuthor" name="Author" size="1">
							<option value=""></option>
<%
			outLst = rto.getUserLstOpts();
			
			x = outLst.size();
			
			for( i = 0; i < x; ++i ) {
				
				out.println( outLst.get( i ) );
			}	
%>
						</select>
					</td>
										
					<td class="work">
						<table border="0"><tr><td>
							<input name="CmpDateTime" type="hidden" value="<%= rlo.m_paramMap.get( "CmpDateTime" ) %>">
							<input id="butCmpDateTime" type="button" value="<%= rlo.m_paramMap.get( "CmpDateTime" ) %>" onClick="toggleCompBut( 'CmpDateTime' );">
						</td><td>							
							<input id="fltDateTime" name="DateTime" type="text" size="10" value="<%= rlo.m_paramMap.get( "DateTime" ) %>"/>
						</td><td>
							<a href="javascript:NewCal('fltDateTime','ddmmmyyyy',false,'24T')"><img src="rsc/cal.gif" width="16" height="16" border="0" alt="Pick a date"></a>
						</td></tr></table>
					</td>

					<td class="work">

						<select id="fltAppl" name="Appl" size="1">
							<option value=""></option>
<%
		rTbl = uTool.getApplLst();

		if( rTbl.isOK() ) {

			x = rTbl.size();

			for( i = 0; i < x; ++i ) {
				
				aVal = rTbl.getCell( 0, i );

				out.println( "<option value=\"" + aVal + "\">" + aVal + "</option>" );
			}
		}
%>
						</select>
					</td>

					<td class="work">					
						<table border="0"><tr><td>
							<input name="CmpShipRel" type="hidden" value="<%= rlo.m_paramMap.get( "CmpShipRel" ) %>">
							<input id="butCmpShipRel" type="button" value="<%= rlo.m_paramMap.get( "CmpShipRel" ) %>" onClick="toggleCompBut( 'CmpShipRel' );">
						</td><td>							
							<input id="fltShipRel" name="ShipRel" type="text" size="10" value="<%= rlo.m_paramMap.get( "ShipRel" ) %>"/>
						</td></tr>
						</table>
					</td>

					<td class="work">
						<table border="0"><tr><td>
							<input name="CmpDateTimeShip" type="hidden" value="<%= rlo.m_paramMap.get( "CmpDateTimeShip" ) %>">
							<input id="butCmpDateTimeShip" type="button" value="<%= rlo.m_paramMap.get( "CmpDateTimeShip" ) %>" onClick="toggleCompBut( 'CmpDateTimeShip' );">
						</td><td>							
							<input id="fltDateTimeShip" name="ShpDate" type="text" size="10" value="<%= rlo.m_paramMap.get( "DateTimeShip" ) %>"/>
						</td><td>
							<a href="javascript:NewCal('fltDateTimeShip','ddmmmyyyy',false,'24T')"><img src="rsc/cal.gif" width="16" height="16" border="0" alt="Pick a date"></a>
						</td></tr></table>
					</td>
				</tr>
				</form>				
				<tr>
<%
		// Row for sort icons

		part1 = "<td class=\"work\" width=\"48\"><input type=\"image\" src=\"rsc/ArrDwn.gif\" alt=\"Sort\" onclick=\"sortTbl('DocLst', 'aDwn', ";
		part2 = ", 3, 0)\"/><input type=\"image\" src=\"rsc/ArrUp.gif\" alt=\"Sort\" onclick=\"sortTbl('DocLst', 'aUp', ";
		part3 = ", 3, 0)\"/></td>";

		for( i = 0; i < cols; i++ ) {
		
			out.println( part1 + i + part2 + i + part3 );
		}
%>
				</tr>

				<%-- form name="LstForm" action="UpdQNDoc" method="post" target="ifrmExecDial">
				<input name="QNA" type="hidden" id="idLstFormQNA" value=""/ --%>

<%	// and the actual list
				
		x = docLst.size();

		for( i = 0; i < x; i++ ) {

			data = (String[])docLst.get( i );

			//out.println( "<tr id=\"" + data[0] + "\" onMouseover=\"mOv(this.id)\" onMouseout=\"mOut(this.id, 'white')\">" );
			out.println( "<tr id=\"" + data[0] + "\" onMouseover=\"mOv(this.id)\" onMouseout=\"mOut(this.id, 'white')\" onClick=\"showShpLstMenu(this.id)\">" );
			
			//out.println( "<tr>" );
			//line = "<td class=\"work\" onClick=\"showShpLstMenu(parentNode.id)\">";
			line = "<td class=\"work\">";
			
			// Status
			out.println( line + rto.m_resBndl.getString( "valStat_" + data[7] ) + "</td>" );	
			
			// Assigned
			out.println( line + data[2] + "</td>" );			

			// Author
			out.println( line + data[3] + "</td>" );
			
			//Group
			//out.println( line + data[1] + "</td>" );

			// DateTime
			//rollback for filter. Refactor all datetimes to drop the "T"
			//out.println( line + BTools.getDateFromISODateTime( data[2] ) + "&nbsp;" + BTools.getTimeFromISODateTime( data[2] ) + "</td>" );
			out.println( line + data[5] + "</td>" );

			// Appl
			out.println( line + data[6] + "</td>" );

			// ShipRel
			out.println( line + data[8] + "</td>" );

			// DateTimeShip
			out.println( line + data[9] + "</td>" );

			// Cmnt
			out.println( line + data[4] + "</td>" );
			
			out.println( "</tr>" );
		}
		
		//out.println( part1 + i + part2 + i + part3 );

		//out.println( "<input name=\"Lines\" type=\"hidden\" value=\"" + x + "\"/>" ); 
%>
				<%-- /form --%>

		</table>

<%
	}

	if( res.isOK() ) {

		out.println( "<script type=\"text/javascript\">notify( \"" + ntfyMsg + "\" );</script>" );	
	}
	else {

		//out.println( "<script type=\"text/javascript\">notifyErr( \"" + res.getRsltFinalMsg() + "\" );</script>" );
		//sTools.logErr( this, request, res );

		int ii, xx;
		ArrayList<String> addInfo;

		String ss;
		
		addInfo = res.getRsltAddInfo();

		out.println( "### piQa Error Info ###<br>" );
		
		out.println( "Session ID: '" + request.getSession().getId() + "'<br>" );

//	 add user and application info!						
		/*			
   		out.println( "Path: '" + request.getPathInfo() + "'<br>" );
			out.println( "Path2: '" + request.getContextPath() + "'<br>" );
			out.println( "Path3: '" + request.getPathTranslated() + "'<br>" );
			out.println( "Path4: '" + request.getRequestURI() + "'<br>" );
			out.println( "Path: '" + request.getServletPath() + "'<br>" );
		*/
			
		out.println( "URL: '" + request.getRequestURL() + "'<br>" );
		
		out.println( "RemUser: '" + request.getRemoteUser() + "'<br>" );
		   
		out.println( "Request string: '" + request.getQueryString() + "'<br>" );
		
		out.println( "--- Rslt info:<br>" );
		   
		xx = addInfo.size();
			
		for( ii = 0; ii < xx; ++ii ) {

			ss = (String)addInfo.get( ii );
			ss += "<br>";
			
			out.println( ss );
		}
		
		out.println( "-- Rslt status: " + RsltStatVal.label[ res.getRsltStatVal() ] + "<br>" );
	}
%>

	<!-- required to fix IE Problem with select fields protruding -->
	<iframe id="selHider" src="javascript:'&lt;html&gt;&lt;/html&gt;';" scrolling="no" frameborder="0" style="position:absolute;width:10;height:10;top:-500;left:50;border:none;display:block;z-index:0;filter:Alpha(opacity=0);"></iframe>

	<div id="dialButMenu" style="visibility:hidden; position:absolute; top:-500; left:50;">
		<table class="dial" id="tbPopButMenu">
		</table>
	</div>

<!--  %@ include file="jspf/ComnDial.jspf" % Not required, frame got the same and interferes! -->

<%-- %@ include file="jspf/ErrHndl.jspf" % --%>

<%
	dBAcc.close();
%>

</body>
</html>