<!-- QANav Report Tracker Copyright 2004 Ronald D. Grindle -->
<%@ page language="java" pageEncoding="utf-8" contentType="text/html;charset=utf-8" %>
<%@ page errorPage="/ErrPage.jsp" %>

<%@ page import="com.qanavigation.Basics.*" %>
<%@ page import="com.qanavigation.QNservices.*" %>

<%

	SrvltReqTools sTools;

	String para;
	RsltString rval;
	String pval;

	Enumeration e;

	try {

		sTools = new SrvltReqTools( this, request );
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<title>Test2.jsp</title>
</head>

<body>

	<h2>JSP Test Page</h2>

	<%@ page import="java.util.*" %>
	<%@ page import="java.io.*" %>
	<%@ page import="javax.servlet.*" %>

	<% 
		int i, x;

		String line;
		String pName;
		String val;
		RsltString rVal;

		ArrayList<String> paramLst = new ArrayList();

		/* parameters ---------------------------------- */

		String type = null;
		String type1 = request.getHeader("Content-Type");
		String type2 = request.getContentType();
		// If one value is null, choose the other value
		if (type1 == null && type2 != null) {
			type = type2;
		}
		else if (type2 == null && type1 != null) {
			type = type1;
		}
		// If neither value is null, choose the longer value
		else if (type1 != null && type2 != null) {
			type = (type1.length() > type2.length() ? type1 : type2);
		}

		out.println( "/r/n<p>Type1: '" + type1 + "'</p>" );
		out.println( "/r/n<p>Type2: '" + type2 + "'</p>" );
		
		String enc = request.getCharacterEncoding();
		out.println( "/r/n<p>enc: '" + enc + "'</p>" );

		out.println( "/r/n<p>Is multipart: " + sTools.isMulti() + "</p>" );

		//ServletInputStream in = request.getInputStream();

		BufferedReader in = request.getReader();

		out.println( "/r/n<p>'" + in.ready() + "'</p>" );

		line = request.getQueryString();

		out.println( "/r/n<p>Query String: '" + line + "'</p>" );

		line = request.getMethod();

		out.println( "/r/n<p>Method: '" + line + "'</p>" );

		//in.reset();

		//out.println( "<p>'" + in.ready() + "'</p>" );

		//byte[] b = new byte[256];

		//i = in.readLine( b,  0, 256);

		//out.println( "<p>'" + i + "'</p>" );
		out.println( "/r/n<p>data</p>/r/n<pre>" );

		while( (line = in.readLine()) != null ) {

				out.println( "<p>'" + line + "'</p>" );		
		}
		out.println( "</pre>/r/n<p>data end</p>" );
%>
		<hr>
<% 
out.println( "/r/n<p>Txt: '" + sTools.getVal( "Txt" ).getString() + "'</p>" );

		/* attributes ---------------------------------- */

		out.println( "/r/n<p><b>Attribute list:</b>/r/n<ul>" );

		e = request.getAttributeNames();

		for (; e.hasMoreElements() ;) {

			para = (String)e.nextElement();

			pval = (String)request.getAttribute( para ); 
			
			out.println( "/r/n<li>'" + para + "', value: '" + pval + "'</li>" );
		}

		out.println( "/r/n</ul>" );
	}
	catch( Exception excp ) {

		int i, x;
		Throwable cause;
		StackTraceElement[] ste;
		String msg;
		
		msg = excp.getMessage();
		
		if( null != msg ) {
			
			out.println( "/r/n<p>Msg: '" +  msg + "'" );	
		}
		
		out.println( "/r/n<br>Excp: '" + excp.toString() + "'" );
	
		cause = excp.getCause();
		
		if( null != cause ) {
			
			out.println( "/r/n<br>Cause: '" + excp.getCause().toString() + "'</p>" );
		}
		
		ste = excp.getStackTrace();
		
		x = ste.length;
		
		if( x > 0 )  {
			
			System.out.println( "/r/n<p>Stack Trace: </p>/r/n<pre>" );
		}

		for( i = 0; i < x; ++i ) {
			
			out.println( "   " + ste[i].toString() );
		}	

		if( x > 0 )  {
			
			System.out.println( "/r/n</pre>" );
		}
	}
%>
<!-- Test code -->
</body>
</html>
