<!-- QANav Report Tracker Copyright 2004 Ronald D. Grindle -->
<%@ page errorPage="/ErrPage.jsp" %>
<%@ page isThreadSafe="false" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt" %>

<%@ page import="java.util.ArrayList" %>
<%@ page import="com.qanavigation.Basics.*" %>
<%@ page import="com.qanavigation.QNservices.*" %>

<%@ page import="RTtools.IssRepStat" %>
<%@ page import="RTtools.UserMailTool" %>
<%@ page import="RTtools.QNDocMan" %>

<fmt:setBundle basename="QNLabels"/>

<%@ include file="jspf/UserRoles.jspf" %>

<%
	int i, x;
	int butCnt = 0;

	String assGroup = "";
	String docNum;
	String oStr;
	String qStr = "";
	String title;
	String UID;
	String user;
	String uGroup;

	String lnk;
	String mMsg;
	String pMsg;
	String mSubj;
	String rqTail = "";
	String sender;
	String senderClear;
	String theUrl = "";

	RsltTable m_AssgnLst;
	RsltTable m_ShpDocLst = null;

	RsltString rUID = new RsltString();
	RsltString rVal;

	IssRepStat issStatObj;

	//ResourceBundle resBndl = ResourceBundle.getBundle( "QNLabels", request.getLocale() );
	QNRscBundle resBndl = new QNRscBundle( "QNLabels", request.getLocale() );

	Rslt res = new Rslt( true );

	SrvltReqTools sTools = new SrvltReqTools( this, request );

	QNDBacc2 dBAcc = new QNDBacc2();

	QNDocMan qnDm = new QNDocMan( dBAcc.m_DB, "IssReport" );

	UserTool uTool = new UserTool( dBAcc.m_DB );

	UID = sTools.checkParam( "UID" );

	user = request.getRemoteUser();
	uGroup = uTool.getGroupForUser( user );

	boolean isYours = false;
	boolean isInYGrp = false;
	
	evalUser( request, resBndl );

	RsltString rAssignee = qnDm.getAssignee( UID );

	if( (user.compareTo( rAssignee.getString() ) == 0) || isAdm ) {

		isYours = true;
	}

	if( isSup ) {

		isInYGrp = true;
	}
	else {

// fix when overhauling		
		//isInYGrp = uTool.docIsInYourGroup( UID, uGroup );
	}

	assGroup = uGroup;

	//m_AssgnLst = uTool.getLst4Assgn( assGroup );
	m_AssgnLst = uTool.getLst4Assgn( "" );

//out.println( "<p>isInYGrp: " + isInYGrp + " " + user + " " + UID + "</p>" );

	// Saving a new report
	if( sTools.isExpVal( "QNA", "IssIss" ).isOK() ) {

		IssRepBld irb = new IssRepBld( dBAcc.m_DB, sTools, QNDefs.c_RMFilePath );

		if( res.checkRslt( irb ) ) {

	irb.bldIssRep( false );
		}

		if( res.checkRslt( irb ) ) {
		
	 rUID = irb.save2DB( user, false );
		}

		if( res.checkRslt( rUID ) ) {

			UID = rUID.getString();

			UserMailTool mt = new UserMailTool( dBAcc.m_DB );

			title =  sTools.getStrVal( "Title" );
			docNum = irb.getDocNum();

			lnk = "RepIss.jsp?QNA=EditProb&UID=" + UID;

			sender = resBndl.getString( "valSenderMail" );
			senderClear = resBndl.getString( "valSenderClear" );

			/* */
			mSubj = SFormatter.format( resBndl.getString( "lblNewIssRep" ), docNum );

			mMsg = "<p>" + mSubj + ":</p>";
			mMsg += "<p><a href=\"" + theUrl + "\">" + title + "</a></p>";

			pMsg = mSubj;
			pMsg += "\n" + theUrl + " (" + title + ")";

			mt.mailToSupV( mSubj, pMsg, mMsg, sender, senderClear );

			qStr = "VQANavDoc?QNA=" + QNDefs.c_QNAViewIss + "&UID=" + UID;

			rqTail = "?QNA=" + QNDefs.c_QNAViewIss + "&UID=" + UID;
		}
	}

	// View an existing report
	if( sTools.isExpVal( "QNA", QNDefs.c_QNAViewIss ).isOK() ) {

		qStr = "VQANavDoc?" + request.getQueryString();

	}
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
	<head>

		<meta name="DC.Title" content="Issue Report View Frame">
		<meta name="DC.Creator" content="Ronald D. Grindle">
		<meta name="DC.Publisher" content="QA Navigation">
		<meta name="DC.Date" content="2004-07-31">
		<meta name="DC.Identifier" content="http://www.qa-navigation.com/">
		<meta name="DC.Rights" content="Alle Rechte liegen beim Autor">
		
		<link rel=stylesheet type="text/css" href="QNStyle.css">
		<link href="favicon.ico" rel="shortcut icon">

		<title>Issue Report View Frame</title>

<script type="text/javascript" src="incl/AjxTools.js"></script>
<script type="text/javascript" src="incl/dhtml.js"></script>
<script type="text/javascript" src="incl/DialTools.js"></script>
<script type="text/javascript" src="incl/PnlTools.js"></script>
<script type="text/javascript" src="incl/RManTools.js"></script>
<script type="text/javascript" src="incl/RepVTools.js"></script>
<script type="text/javascript" src="incl/datetimepicker.js"></script>

<script type="text/javascript">
<!--

<%@ include file="jspf/PnlToolsLbls.jspf" %>

var m_DocType = "IssReport";

var m_href = self.location.href + <% out.print( "\"" + rqTail + "\"" ); %>;;


//alert( m_href );

var m_editAppl = "RepIss.jsp";
var m_editQNA = "EditIss";

var m_User = <% out.print( "\"" + request.getRemoteUser() + "\"" ); %>;

var blblChgStat = <% out.print( "\"" + resBndl.getString( "blblChgStat" ) + "\"" ); %>;
var lblAssLst = <% out.print( "\"" + resBndl.getString( "lblAssLst" ) + "\"" ); %>;
var lblIssStat = <% out.print( "\"" + resBndl.getString( "lblIssStat" ) + "\"" ); %>;

var blblGiveAns = <% out.print( "\"" + resBndl.getString( "blblGiveAns" ) + "\"" ); %>;
var blblReqComm = <% out.print( "\"" + resBndl.getString( "blblReqComm" ) + "\"" ); %>;

var lblAddComm = <% out.print( "\"" + resBndl.getString( "lblAddComm" ) + "\"" ); %>;
var lblCloseRep = <% out.print( "\"" + resBndl.getString( "lblCloseRep" ) + "\"" ); %>;
var lblCmmnt = <% out.print( "\"" + resBndl.getString( "lblCmmnt" ) + "\"" ); %>;
var lblCommReq = <% out.print( "\"" + resBndl.getString( "lblCommReq" ) + "\"" ); %>;
var lblDate = <% out.print( "\"" + resBndl.getString( "lblDate" ) + "\"" ); %>;
var lblFile = <% out.print( "\"" + resBndl.getString( "lblFile" ) + "\"" ); %>;

var lblFixDesc = <% out.print( "\"" + resBndl.getString( "lblFixDesc" ) + "\"" ); %>;

var lblGiveAnsw = <% out.print( "\"" + resBndl.getString( "lblGiveAnsw" ) + "\"" ); %>;
var lblLbl = <% out.print( "\"" + resBndl.getString( "lblLbl" ) + "\"" ); %>;
var lblPath = <% out.print( "\"" + resBndl.getString( "lblPath" ) + "\"" ); %>;
var lblIssClose = <% out.print( "\"" + resBndl.getString( "lblIssClose" ) + "\"" ); %>;
var lblIssRejctd = <% out.print( "\"" + resBndl.getString( "lblIssRejctd" ) + "\"" ); %>;

var lblRejIss = <% out.print( "\"" + resBndl.getString( "lblRejIss" ) + "\"" ); %>;
var lblRepReOp = <% out.print( "\"" + resBndl.getString( "lblRepReOp" ) + "\"" ); %>;
var lblReqComm = <% out.print( "\"" + resBndl.getString( "lblReqComm" ) + "\"" ); %>;
var lblResponse = <% out.print( "\"" + resBndl.getString( "lblResponse" ) + "\"" ); %>;

var lblShipSol = <% out.print( "\"" + resBndl.getString( "lblShipSol" ) + "\"" ); %>;
var lblSolRej = <% out.print( "\"" + resBndl.getString( "lblSolRej" ) + "\"" ); %>;
var lblTstOK = <% out.print( "\"" + resBndl.getString( "lblTstOK" ) + "\"" ); %>;
var m_UID = <% out.print( "\"" + UID + "\"" ); %>;

var m_ImHere =true;

window.onresize = rsz;


// ---------------------------
function printDoc() {

	frm = getFrame( "ViewFrame" );

	frm.focus();
	frm.print();
}

// ------------------------------------------
function rsz() {

	h = getWinHight();

	h -= 110;

	theFrame = document.getElementById( "ViewFrame" );

	theFrame.setAttribute("height", h, "false");
}

// ------------------------------------------
function startUp() {

	
	rsz();

	//m_ImHere = true;
}

// -->
</script>
</head>

<body bgcolor="silver" class="QANframe" onload="startUp()">


	<iframe id="ViewFrame" src="<%= qStr %>" width="98%" height="200" application="yes">

		<p>Processing failed. Your browser does not allow frames. Please set up your browser to allow frames.</p>
	</iframe>

<%
	/* out.println( "QNA: " + sTools.getStrVal( "QNA" ) );
		out.println( "qStr: " + qStr );
		out.println( "Req: " + request.getQueryString() ); */
%>

	<table id="tbButMenu" border="0" style="margin-top:10px;"><tr>
<%
	if( res.isOK() ) {

		rVal = qnDm.getIssStat( UID );

		issStatObj = new IssRepStat( rVal.getString() );

		if( issStatObj.notClosed() ) {

	if( isCoo ) {
%>
		<td><button type="button" onClick="setPrio()" style="width:120pt"><fmt:message key="blblSetPrio"/></button></td>
<%
	}
	if( issStatObj.nextEdit1( isYours ) && isYours ) {
%>
		<td><button type="button" onClick="subEdit()" style="width:120pt"><fmt:message key="blblEdit"/></button></td>	

<%
		}	
		if( issStatObj.nextBack2Draft() && isSup ) {
	%>
		<td><button type="button" onClick="setStat( 'dr' )" style="width:120pt"><fmt:message key="blblSetDraft"/></button></td>	

<%
		}
		if( issStatObj.nextAssgn() ) {

			if( isSrvc && isYours ) {
	%>
		<td><button type="button" onClick="rejectIss()" style="width:120pt"><fmt:message key="blblReject"/></button></td>
<%
	}			
		if( isSrvc && isInYGrp ) {
%>
		<td><button type="button" onClick="assignTo( 'as' )" style="width:120pt"><fmt:message key="blblAssign"/></button></td>
<%
	}
	} // if( issStatObj.nextAssgn() )

	if( isSrvc && isYours ) {
	
		if( issStatObj.nextEval() ) {
%>
		<td><button type="button" onClick="setStat( 'ev' )" style="width:120pt"><fmt:message key="blblEval"/></button></td>
<%
	}
		if( issStatObj.nextCmmntReq() ) {
%>
		<td><button type="button" onClick="reqComm()" style="width:120pt"><fmt:message key="blblReqComm"/></button></td>
<%
	}
		if( issStatObj.nextFix() ) {
%>
		<!-- td><button type="button" onClick="assignTo( 'fx' )" style="width:120pt"><fmt:message key="blblFix"/></button></td -->
		<td><button type="button" onClick="openFix()" style="width:120pt"><fmt:message key="blblFix"/></button></td>

		<td><button type="button" onClick="rejectIss()" style="width:120pt"><fmt:message key="blblReject"/></button></td>
<%
	}

		if( issStatObj.nextShip() ) {
%>
		<td><button type="button" onClick="setStat( 'sh' )" style="width:120pt"><fmt:message key="blblShip"/></button></td>
<%
	}
		if( issStatObj.isComReq() ) {
%>
		<td><button type="button" onClick="givAns()" style="width:120pt"><fmt:message key="blblGiveAns"/></button></td>
<%
	}
		if( issStatObj.nextClose() ) {
%>
		<td><button type="button" onClick="closeRep()" style="width:120pt"><fmt:message key="blblClose"/></button></td>

		<td><button type="button" onClick="reopen()" style="width:120pt"><fmt:message key="blblRejSol"/></button></td>
<%
	}
	} //if( isSrvc && isYours )
%>
	</tr><tr>
<%
	if( isSrvc && isInYGrp ) {
%>
		<td><button type="button" onClick="assignTo( '' )" style="width:120pt"><fmt:message key="blblFrwrd"/></button></td>
<%
	}
	if( isAdm ) {
%>
		<td><button type="button" onClick="chgStat()" style="width:120pt"><fmt:message key="blblChgStat"/></button></td>
<%
	}
	if( isSrvc ) {
%>
		<td><button type="button" onClick="appFile()" style="width:120pt"><fmt:message key="blblAppFile"/></button></td>
		<td><button type="button" onClick="addComm()" style="width:120pt"><fmt:message key="blblAddComm"/></button></td>
<%
	} 
		}
%>
		<td><button type="button" onClick="printDoc()" style="width:120pt"><fmt:message key="blblPrint"/></button></td>
<%
	}
%>
		</tr>
	</table>

	<iframe id="selHider" src="javascript:'&lt;html&gt;&lt;/html&gt;';" scrolling="no" frameborder="0" style="position:absolute;width:10;height:10;top:-500;left:50;border:none;display:block;z-index:0;filter:Alpha(opacity=0);"></iframe>

<%@ include file="jspf/ProbDial.jspf" %>
<%@ include file="jspf/ComnDial.jspf" %>
<%@ include file="jspf/ProbManDial.jspf" %>
<%@ include file="jspf/ErrHndl.jspf" %>

<%
	dBAcc.close();
%>

</body>
</html>