// QANav Report Tracker Copyright 2009 Ronald D. Grindle

package RTtools;

import com.qanavigation.QNservices.QNDefs;


/**
 * @author RDG
 *
 */
public class CRRepStat extends QNDocStat {
	
	/**
	 * 
	 * @param p_Stat
	 */
	public CRRepStat( String p_Stat ) {
		
		super( p_Stat ); 
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isSub() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatNew ) == 0 );
//isTrue = true;
		return isTrue;		
	}
	
	/**
	 * 
	 * @return
	 */		
	public boolean nextAssgn() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatNew ) == 0 );
			
//isTrue = true;		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean nextBaEst() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatNew ) == 0 );
			
//isTrue = true;		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean nextBaEsted() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( "baEst" ) == 0 );
			
//isTrue = true;		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean nextChgReq() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( "estSub" ) == 0 );
			
//isTrue = true;		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */		
	public boolean nextClose() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( "preShp" ) == 0 );
		isTrue |= ( m_Stat.compareTo( QNDefs.c_StatRej ) == 0 );
		
//isTrue = true;			
		return isTrue;	
	}
	
	
	/**
	 * 
	 * @return
	 */
	public boolean nextCont() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatBaWai ) == 0 ) ;
		isTrue |= ( m_Stat.compareTo( QNDefs.c_StatBaWaiOrd ) == 0 ) ;
		isTrue |= ( m_Stat.compareTo( QNDefs.c_StatPostP ) == 0 ) ;
			
//isTrue = true;		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean nextEstSub() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( "impEsted" ) == 0 );
			
//isTrue = true;		
		return isTrue;		
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean nextImpEst() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( "baEsted" ) == 0 );
			
//isTrue = true;		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean nextImpEsted() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( "impEst" ) == 0 );
			
//isTrue = true;		
		return isTrue;
	}	

	/**
	 * 
	 * @return
	 */
	public boolean nextImpIng() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( "chgReq" ) == 0 );
		isTrue |= nextChgReq();
			
//isTrue = true;		
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean nextPreShp() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( "sysTst" ) == 0 );
			
//isTrue = true;		
		return isTrue;
	}
	
	public boolean nextRej() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatRej ) != 0 );
			
//isTrue = true;		
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */
	public boolean nextSysTst() {

		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( "impIng" ) == 0 );
			
//isTrue = true;		
		return isTrue;
	}

	
	/**
	 * 
	 * @return
	 */
	public boolean notWai() {
		
		boolean isTrue = ( m_Stat.compareTo( QNDefs.c_StatBaWai ) != 0 ) ;
		isTrue &= ( m_Stat.compareTo( QNDefs.c_StatBaWaiOrd ) != 0 ) ;
		isTrue &= ( m_Stat.compareTo( QNDefs.c_StatPostP ) != 0 ) ;
		isTrue &= ( m_Stat.compareTo( QNDefs.c_StatRej ) != 0 ) ;
//isTrue = true;
		return isTrue;
	}	

}
