<!-- QANav Report Tracker Copyright 2004 Ronald D. Grindle -->
<!-- Account Managing Page -->
<%@ page language="java" pageEncoding="utf-8" contentType="text/html;charset=utf-8" %>
<%@ page import="com.qanavigation.Basics.*" %>
<%@ page import="com.qanavigation.QNservices.*" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt" %>
<fmt:setBundle basename="QNLabels"/>

<%
	int i, x;

	String val;
	String tableName;
	String appx;
	String[] colNames = {""};

	String Mail = "";

	Rslt res = new Rslt( true );

	SrvltReqTools sTools = new SrvltReqTools( this, request );
	QNDBacc2 dBAcc = new QNDBacc2();

	res.checkRslt( dBAcc );

	String User = request.getRemoteUser();

	if( res.checkRslt( sTools ) ) {

		tableName = "Users";
		appx = "WHERE Name = '" + User + "'";
		colNames[0] = "Mail";

		RsltTable rTbl = dBAcc.m_DB.select( tableName, colNames, appx );

		if( res.checkRslt( rTbl ) ) {
				
			Mail = rTbl.getCell( 0, 0 );
		}
	}
%>

<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
  <head>
    <title>QANav Personal Account Management</title>

		<meta name="DC.Title" content="Account Management">
		<meta name="DC.Creator" content="Ronald D. Grindle">
		<meta name="DC.Publisher" content="QA Navigation">
		<meta name="DC.Date" content="2004-08-12">
		<meta name="DC.Identifier" content="http://www.qa-navigation.com/">
		<meta name="DC.Rights" content="Alle Rechte liegen beim Autor">

		<link rel=stylesheet type="text/css" href="../incl/DialStyle.css" >

<script type="text/javascript" src="../incl/dhtml.js"></script>
<script type="text/javascript" src="../incl/DialTools.js"></script>

<script type="text/javascript">
<!--

var m_href = self.location.href;

// ----------------------------------------------
// execution window
function execWinDone() {

	hideD( "dialExecWin" );
	//blurFocus( "butExecWinOK" );

	theFrm = document.getElementById( "ifrmExecDial" );
	theFrm.src = "";

	myReload();
}

// ----------------------------------------------
function setPW() {

	pw = document.getElementById( "inPW" );
	pwr = document.getElementById( "inPWrep" );

	if( pw.value != pwr.value ) { 
		
		alert( "Passwords are not identical!" );
	}
	else {

		showD( "dialExecWin", 50 );
		setFocus( "butExecWinOK" );

		theForm = document.getElementById( "formSetPW" );
		theForm.submit();
	}
}

// ----------------------------------------------
function setMail() {

	showD( "dialExecWin", 50 );
	setFocus( "butExecWinOK" );

	theForm = document.getElementById( "formSetMail" );
	theForm.submit();
}

// ----------------------------------------------
function Startup() {

	
}

// -->
</script>
</head>

<body onLoad="Startup()">

	<!-- required to fix IE Problem with select fields protruding -->
	<iframe id="selHider" src="javascript:'&lt;html&gt;&lt;/html&gt;';" scrolling="no" frameborder="0"
		style="position:absolute;width:10;height:10;top:-500;left:50;border:none;display:block;z-index:0;filter:Alpha(opacity=0);"></iframe>

	<p style="font-size:150%"><b>User '<%= User %>'</b></p>

<%@ include file="../jspf/ComnDial.jspf" %>

	<form id="formSetMail" action="../AdmUser" method="post" target="ifrmExecDial">
		<input name="QNA" type="hidden" value="SetMail"/>
		<input name="User" type="hidden" value="<%= User %>"/>	
		<table>
			<tr>
				<td width="70px">Mail</td>
				<td><input ID="inMail" name="Mail" type="text" size="30" value="<%= Mail %>"/></td>
				<td><button Name="btnSetMail" ID="btnSetMail" onClick="setMail()">Set Mail</button></td>
			</tr>
		</table>
	</form>	

	<p></p>

	<form id="formSetPW" action="../AdmUser" method="post" target="ifrmExecDial">
		<input name="QNA" type="hidden" value="SetPW"/>
		<input name="User" type="hidden" value="<%= User %>"/>
		<table>
			<tr>
				<td width="70px">PW</td>
				<td><input ID="inPW" name="PW" type="password" size="30"/></td>
			</tr>
			<tr><td>PW repeat</td>
				<td><input ID="inPWrep" name="PWrep" type="password" size="30"/></td></tr>
			<tr>
				<td><button Name="btnSetPW" ID="btnSetPW" onClick="setPW()">Set PW</button></td>
				<td></td>
			</tr>
		</table>
	</form>	

	<p></p>

	<table>
		<tr>
			<td>
				<button Name="Back" ID="btnBack" onClick="javascript:history.back()">Back</button>
			</td>
			<!-- td>
				<button Name="Quit" ID="btnQuit" onClick="logOff()">Quit</button>
			</td -->
		</tr>
	</table>

	<p></p>
<%

	dBAcc.close();

	if( res.notOK() ) {

		out.println( "<p>Error, check log.</p>" );
		SrvltReqTools.logErr( this, request, res );
	}
%>

</body>
</html>
