// QANav Report Tracker Copyright 2008 -2009 Ronald D. Grindle

package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import com.qanavigation.QNservices.QNDBacc2;

/**
 * CR Report List Base Object
 * @author RGDM2
 *
 */
public class CRLstObj extends RTLstLstObj {
	
	public boolean m_modeIsSLS = false;
	
	public boolean m_roleIsCRSup = false;
	
	public boolean m_roleIsCRSrvc = false;
	
	// -------------------------
	public CRLstObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {
		
		super( p_Srvl, p_Request, p_dBAcc );
		
		initMe();
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "CRLstObj", "CRLstObj", "", "" );
		}
	}
	
	// -------------------------
	private void initMe() {
	
		m_roleIsCRSup = m_uRTool.isCRSuper();
		m_roleIsCRSrvc = m_uRTool.isCRSrvc();
		m_roleIsSrvc = m_roleIsCRSrvc;
	}
	
	// --------------------------
	public void  prepare() {
		
		prepParam( "Appl", "", "false" );
		prepParam( "Assignd", "", "false" );
		prepParam( "Author", "", "false" );
		prepParam( "CRStat", "", "false" );
		prepParam( "DateTime", "CmpDateTime", "false" );
		prepParam( "ExtID", "CmpExtID", "true" );
		prepParam( "SoftRel", "CmpSoftRel", "false" );
		//prepParam( "Prio", "" );
		prepParam( "Ticket", "CmpTicket", "true" );
		prepParam( "Title", "CmpTitle", "false" );				
		
		if( m_roleIsCRSrvc ) {
			
			if( m_modeIsAll ) {
			
				m_assGroup = "";
			}
			else {
	
				if( !( m_roleIsCRSup ) ) { 
	
					m_uGroup = m_yGroup;
				}
			}
		}
		else {
	
			m_paramMap.put( "Author", m_User );
			m_strRO = " readonly";
		}		
	}
}
