package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;

/**
 * Fix Object
 *
 */
public class FixObj extends RTRepObj {
	
	public FixRepBld m_fxb;

	/**
	 * 
	 * @param p_srvl
	 * @param p_request
	 * @param p_dBacc
	 */
	public FixObj(HttpServlet p_srvl, HttpServletRequest p_request, QNDBacc2 p_dBacc) {

		super( p_srvl, p_request, p_dBacc );
		
		m_fxb = new FixRepBld( m_xDB, m_sTools, QNDefs.c_RMFilePath );
		
		if( checkRslt( m_fxb ) ) {	
		
			initMe();
		}
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "FixObj", "FixObj", "", "" );
		}
	}

	// ------------------------
	private void initMe() {
		
		init( null, "-none-" );
		
		m_roleIsSrvc = m_uRTool.isFixSrvc();
	}	
}
