//QANav Report Tracker Copyright 2004 - 2008 Ronald D. Grindle
package RTtools;

import com.qanavigation.QNservices.QNDefs;


/**
 * @author RDG
 *
 */
public class QNDocStat  {
	
	protected String m_Stat;
	
	/**
	 * 
	 * @param p_Stat
	 */
	public QNDocStat( String p_Stat ) {
		
		m_Stat = p_Stat; 
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isComReq() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatCmntReq ) == 0 );
//isTrue = true;
		return isTrue;		
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean isDraft() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatDraft ) == 0 );
//isTrue = true;
		return isTrue;		
	}	
	 
	 /**
	  * 
	  * @return
	  */
	public boolean isRespGiv() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatRespGiven ) == 0 );
//isTrue = true;
		return isTrue;		
	}
	

	/**
	 * 
	 * @return
	 */
	public boolean isNew() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatNew ) == 0 );
//isTrue = true;
		return isTrue;		
	}	

	/**
	 * 
	 * @return
	 */
	public boolean isSub() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatSub ) == 0 );
//isTrue = true;
		return isTrue;		
	}
	
	/**
	 * 
	 * @return
	 */		
	public boolean nextBack2Draft() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatSub ) == 0 );
//isTrue = true;
		return isTrue;		
	}	
	
	/**
	 * 
	 * @return
	 */		
	public boolean nextCmmntReq() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatEval ) == 0 );
//isTrue = true;
		return isTrue;		
	}

	/**
	 * Edit1: still draft.
	 * @return
	 */		
	public boolean nextEdit1( boolean p_isYours ) {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatDraft ) == 0 );
		isTrue &= p_isYours;
		
		
//isTrue = true;
		return isTrue;		
	}
	
	/**
	 * Edit2: restricted correction mode.
	 * @return
	 */		
	public boolean nextEdit2( boolean p_isYours ) {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatDraft ) != 0 );
		isTrue &= ( m_Stat.compareTo( QNDefs.c_StatClosed ) != 0 );
		isTrue &= p_isYours;
		
		
//isTrue = true;
		return isTrue;		
	}	
	
	/**
	 * 
	 * @return
	 */		
	public boolean nextEst() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatEval ) == 0 );
		isTrue |= ( m_Stat.compareTo( QNDefs.c_StatRespGiven ) == 0 );
		isTrue |= ( m_Stat.compareTo( QNDefs.c_StatEsti ) == 0 );		
		isTrue |= ( m_Stat.compareTo( QNDefs.c_StatFixn ) == 0 );
//isTrue = true;
		return isTrue;
	}	
	
	/**
	 * 
	 * @return
	 */		
	public boolean nextEval() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatAssgnd ) == 0 );
		isTrue |= ( m_Stat.compareTo( QNDefs.c_StatRespGiven ) == 0 );
//isTrue = true;
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */		
	public boolean nextFix() {
		
		boolean isTrue;
		
		isTrue = ( m_Stat.compareTo( QNDefs.c_StatEval ) == 0 );
		isTrue |= ( m_Stat.compareTo( QNDefs.c_StatRespGiven ) == 0 );
		isTrue |= ( m_Stat.compareTo( QNDefs.c_StatFixn ) == 0 );
		isTrue |= ( m_Stat.compareTo( QNDefs.c_StatEsti ) == 0 );
//isTrue = true;
		return isTrue;
	}
	
	/**
	 * 
	 * @return
	 */
	public boolean notClosed() {
		
		boolean isTrue = ( m_Stat.compareTo( QNDefs.c_StatClosed ) != 0 ) ;
//isTrue = true;
		return isTrue;
	}	
}
